<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Oasis3-MCT: mod_oasis_method Module Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Oasis3-MCT
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions/Subroutines</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">mod_oasis_method Module Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>High level OASIS user interfaces.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions/Subroutines</h2></td></tr>
<tr class="memitem:ad266b77f6e75f2d150c80374a841a43c"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#ad266b77f6e75f2d150c80374a841a43c">oasis_init_comp</a> (mynummod, cdnam, kinfo, coupled, commworld)</td></tr>
<tr class="memdesc:ad266b77f6e75f2d150c80374a841a43c"><td class="mdescLeft">&#160;</td><td class="mdescRight">OASIS user init method.  <a href="#ad266b77f6e75f2d150c80374a841a43c">More...</a><br /></td></tr>
<tr class="separator:ad266b77f6e75f2d150c80374a841a43c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fb881336906c9452b6a9f250af9c3d7"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#a4fb881336906c9452b6a9f250af9c3d7">oasis_terminate</a> (kinfo)</td></tr>
<tr class="memdesc:a4fb881336906c9452b6a9f250af9c3d7"><td class="mdescLeft">&#160;</td><td class="mdescRight">OASIS user finalize method.  <a href="#a4fb881336906c9452b6a9f250af9c3d7">More...</a><br /></td></tr>
<tr class="separator:a4fb881336906c9452b6a9f250af9c3d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a093552f9f9895ac79a5fefa043fc5881"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#a093552f9f9895ac79a5fefa043fc5881">oasis_enddef</a> (kinfo)</td></tr>
<tr class="memdesc:a093552f9f9895ac79a5fefa043fc5881"><td class="mdescLeft">&#160;</td><td class="mdescRight">OASIS user interface specifying the OASIS definition phase is complete.  <a href="#a093552f9f9895ac79a5fefa043fc5881">More...</a><br /></td></tr>
<tr class="separator:a093552f9f9895ac79a5fefa043fc5881"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13d6e469ea14642a2e1e6cb807d9b7de"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#a13d6e469ea14642a2e1e6cb807d9b7de">mod_oasis_setrootglobal</a> ()</td></tr>
<tr class="memdesc:a13d6e469ea14642a2e1e6cb807d9b7de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Local method to compute each models' global task ids, exists for reuse in enddef.  <a href="#a13d6e469ea14642a2e1e6cb807d9b7de">More...</a><br /></td></tr>
<tr class="separator:a13d6e469ea14642a2e1e6cb807d9b7de"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a390290b92b6af57b2732cb7521532f1c"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_intwp_p), parameter&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#a390290b92b6af57b2732cb7521532f1c">debug</a> =1</td></tr>
<tr class="separator:a390290b92b6af57b2732cb7521532f1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a405af91a0535e4ce70d55513bb4c3867"><td class="memItemLeft" align="right" valign="top">logical&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#a405af91a0535e4ce70d55513bb4c3867">lg_mpiflag</a></td></tr>
<tr class="separator:a405af91a0535e4ce70d55513bb4c3867"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff65fa61d2762374419fe4c44c0f9282"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_intwp_p)&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__method.html#aff65fa61d2762374419fe4c44c0f9282">mpi_comm_global_world</a></td></tr>
<tr class="separator:aff65fa61d2762374419fe4c44c0f9282"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>High level OASIS user interfaces. </p>
</div><h2 class="groupheader">Function/Subroutine Documentation</h2>
<a id="a13d6e469ea14642a2e1e6cb807d9b7de"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13d6e469ea14642a2e1e6cb807d9b7de">&#9670;&nbsp;</a></span>mod_oasis_setrootglobal()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">subroutine mod_oasis_method::mod_oasis_setrootglobal </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Local method to compute each models' global task ids, exists for reuse in enddef. </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00939">939</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<a id="a093552f9f9895ac79a5fefa043fc5881"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a093552f9f9895ac79a5fefa043fc5881">&#9670;&nbsp;</a></span>oasis_enddef()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_method::oasis_enddef </td>
          <td>(</td>
          <td class="paramtype">integer (kind=ip_intwp_p), intent(inout), optional&#160;</td>
          <td class="paramname"><em>kinfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>OASIS user interface specifying the OASIS definition phase is complete. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">kinfo</td><td>return code </td></tr>
  </table>
  </dd>
</dl>
<ul>
<li>Check enddef called only once per task</li>
<li>Reset mpi_comm_global because active tasks might have been excluded</li>
<li>For active tasks only<ul>
<li>Update mpi_comm_global</li>
<li>Update mpi_root_global</li>
<li>Document</li>
<li>Reconcile partitions, call part_setup</li>
<li>Reconcile variables, call var_setup</li>
<li>Write grid info to files one model at a time</li>
<li>MCT Initialization</li>
<li>Initialize coupling via call to coupler_setup</li>
<li>Call advance_init to initialize coupling fields from restarts </li>
</ul>
</li>
</ul>

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00730">730</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<a id="ad266b77f6e75f2d150c80374a841a43c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad266b77f6e75f2d150c80374a841a43c">&#9670;&nbsp;</a></span>oasis_init_comp()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_method::oasis_init_comp </td>
          <td>(</td>
          <td class="paramtype">integer (kind=ip_intwp_p), intent(out)&#160;</td>
          <td class="paramname"><em>mynummod</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">character(len=*), intent(in)&#160;</td>
          <td class="paramname"><em>cdnam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer (kind=ip_intwp_p), intent(inout), optional&#160;</td>
          <td class="paramname"><em>kinfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">logical, intent(in), optional&#160;</td>
          <td class="paramname"><em>coupled</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer (kind=ip_intwp_p), intent(in), optional&#160;</td>
          <td class="paramname"><em>commworld</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>OASIS user init method. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">mynummod</td><td>* This is COLLECTIVE, all pes must call</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">mynummod</td><td>component model ID</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cdnam</td><td>model name</td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">kinfo</td><td>return code</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">coupled</td><td>flag to specify whether this component is coupled in oasis</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">commworld</td><td>user defined mpi_comm_world to use in oasis </td></tr>
  </table>
  </dd>
</dl>
<ul>
<li>Initialize MPI</li>
<li>Set initial output file, need mpi_rank_world</li>
<li>Initialize namcouple. First on rank 0 to write error messages then on all other ranks. All tasks will read the namcouple file independently.</li>
<li>Check if NFIELDS=0, there is no coupling.</li>
<li>Determine the total number of coupling fields from namcouple. Set maxvar parameter and allocate prism_var.</li>
<li>Store all the names of the fields exchanged in the namcouple</li>
<li>Gather model names from all tasks to generate active model list on all tasks.</li>
<li>Broadcast the model list to all MPI tasks</li>
<li>Compute compid</li>
<li>Re-Set MPI info based on active model tasks</li>
<li>Reset debug levels</li>
<li>Open log files</li>
<li>Set mpi_root_global</li>
<li>Memory Initialization</li>
<li>Timer Initialization</li>
<li>Diagnostics </li>
</ul>

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00046">46</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<a id="a4fb881336906c9452b6a9f250af9c3d7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4fb881336906c9452b6a9f250af9c3d7">&#9670;&nbsp;</a></span>oasis_terminate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_method::oasis_terminate </td>
          <td>(</td>
          <td class="paramtype">integer (kind=ip_intwp_p), intent(inout), optional&#160;</td>
          <td class="paramname"><em>kinfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>OASIS user finalize method. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">kinfo</td><td>return code </td></tr>
  </table>
  </dd>
</dl>
<ul>
<li>Print timer information</li>
<li>Call MPI finalize</li>
<li>Write SUCCESSFUL RUN </li>
</ul>

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00663">663</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a390290b92b6af57b2732cb7521532f1c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a390290b92b6af57b2732cb7521532f1c">&#9670;&nbsp;</a></span>debug</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_intwp_p), parameter mod_oasis_method::debug =1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00034">34</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<a id="a405af91a0535e4ce70d55513bb4c3867"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a405af91a0535e4ce70d55513bb4c3867">&#9670;&nbsp;</a></span>lg_mpiflag</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">logical mod_oasis_method::lg_mpiflag</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00036">36</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
<a id="aff65fa61d2762374419fe4c44c0f9282"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff65fa61d2762374419fe4c44c0f9282">&#9670;&nbsp;</a></span>mpi_comm_global_world</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_intwp_p) mod_oasis_method::mpi_comm_global_world</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="mod__oasis__method_8_f90_source.html#l00037">37</a> of file <a class="el" href="mod__oasis__method_8_f90_source.html">mod_oasis_method.F90</a>.</p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Jun 29 2018 20:52:29 for Oasis3-MCT by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
